/********************************************************
 * MAT 259 - Winter 2017                                *
 * 3D project                                           *     
 *                                                      *
 * Author: Jingi Xiao                                   *
 * Supervisor: George Legrady                           *
 *                                                      *
 * Purpose: Based on my 2D project (average title       *
 *         length), I add another dimension - time, to  *
 *         see how the title length change over time.   *
 *                                                      *
 *                                                      *
 ********************************************************/




import peasy.*;
PeasyCam cam;

import controlP5.*;
ControlP5 cp5;
CheckBox checkbox, checkbox2, checkbox3;
Toggle toggle;
Range range, range2;


Table table;
int numRows;
color clr[] = {#F89167, #F4C356, #E5DF60, #DDF774, #7AFCB6, #52F8F8, #77D4F8, #C3BDF7, #F7ABE2, #F9858D};
color clr2[] = {#A4633D, #917831, #A5A647, #778E42, #508954, #2E9294, #4C7C96, #727296, #9A6F95, #9A5052};

int[][][][] data = new int[10][10][11][10];

int radius= 250;
int len = 500;
int co = 3;

int[] fontColor = {240, 180};
int[] fontSize = {28, 14, 12, 10};
PFont font;

///////   variable to store some value ///////////////
int a, b, c, dist;
int lowY = 0, highY = 11;
int lowS =0, highS =10;

//////////   variables to change states of different parts  ///////////////////////
boolean  flower = false, dot = false, timeline = false, info = true, notation = false, rotate= false;
boolean[] state = {true, true, true, true, true, true, true, true, true, true};

void setup() {
  size(1280, 720, P3D);
  cam = new PeasyCam(this, 0, 0, 0, 1500);
  cam.setWheelScale(0.2);
  cam.setMinimumDistance(-2000);
  cam.setMaximumDistance(3000);

  font = loadFont("SansSerif-24.vlw");
  textFont(font);

/// read data
  table = loadTable("TitleLengthIn11Years.csv", "header");
  numRows = table.getRowCount();
/////store data in a matrix
  for (int i=0; i<numRows; i++) {
    int a  = table.getInt(i, 1)/100;
    int b = table.getInt(i, 1)/10%10;
    int c = table.getInt(i, 1)%10;
    data[a][b][table.getInt(i, 0)-2006][c] = table.getInt(i, 2);
  }

  gui();

  smooth();
}



void draw() {

  background(50);
  surface.setResizable(true);

  noFill();
  drawData();

/// keep cp5 on the top of 3D without rotate when camera angle changes
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  if (info)
    drawInfo();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
  
  
  /// when interact with cp5, keep camera still.
  if (cp5.getWindow().isMouseOver()) {
    cam.setActive(false);
  } else {
    cam.setActive(true);
  }
  
}